import AnimeMainInformation from './lib/interfaces/anime/MainInformation';
import AnimeCharactersAndStaff from './lib/interfaces/anime/CharactersAndStaff';
import MangaMainInformation from './lib/interfaces/manga/MainInformation';
import MangaCharacters from './lib/interfaces/manga/Characters';
import GenreAnimeByGenre from './lib/interfaces/genre/AnimeByGenre';
import GenreMangaByGenre from './lib/interfaces/genre/MangaByGenre';

declare module 'jikan-nodejs' {
  export function itemById(
    type: string,
    mal_id: number,
  ): AnimeMainInformation | MangaMainInformation;

  namespace anime {
    export function mainInformation(mal_id: number): AnimeMainInformation;
    export function charactersAndStaff(mal_id: number): AnimeCharactersAndStaff;
  }

  namespace manga {
    export function mainInformation(mal_id: number): MangaMainInformation;
    export function characters(mal_id: number): MangaCharacters;
  }

  namespace genre {
    export function animeByGenre(
      mal_id: number,
      limit?: number,
      page?: number,
    ): GenreAnimeByGenre;
    export function mangaByGenre(
      mal_id: number,
      limit?: number,
      page?: number,
    ): GenreMangaByGenre;
  }
}
